interface FormOption {
    label: string;
    value: string;
    frontend?: any;
}
interface FormPage {
    id: string;
    endScreen?: boolean;
    elements: FormElement[];
    config?: {
        addFieldsToCustomer?: string[];
        autoSubmit?: boolean;
        allowSkip?: boolean;
    };
    branchingRules?: {
        type: "value";
        name: string;
        value: string;
        nextPageId: string;
    }[];
}
interface FormElement {
    id: string;
    name?: string;
    label?: string;
    help?: string;
    type: "radio" | "text" | "checkbox" | "html";
    options?: FormOption[];
    component: React.FC<any>;
    frontend?: any;
}
interface Form {
    pages: FormPage[];
    config?: {
        progressBar?: boolean;
    };
}

interface FormProps {
    schema: Form;
    formbricksUrl: string;
    formId: string;
    onFinished?: ({ submission }: any) => void;
    onPageSubmit?: ({ page }: any) => void;
}
declare function FormbricksEngine({ schema, formbricksUrl, formId, onFinished, onPageSubmit, }: FormProps): JSX.Element | null;

export { FormbricksEngine };
