"use strict";Object.defineProperty(exports, "__esModule", {value: true});var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/components/FormbricksEngine.tsx
var _react = require('react');

// src/components/EnginePage.tsx

var _reacthookform = require('react-hook-form');
var _jsxruntime = require('react/jsx-runtime');
function EnginePage({
  page,
  onSkip,
  onPageSubmit,
  onFinished,
  submission,
  setSubmission,
  formbricksUrl,
  formId,
  schema
}) {
  const [submissionId, setSubmissionId] = _react.useState.call(void 0, );
  const {
    handleSubmit,
    control,
    register,
    reset,
    formState: {}
  } = _reacthookform.useForm.call(void 0, );
  const [submittingPage, setSubmittingPage] = _react.useState.call(void 0, false);
  const formRef = _react.useRef.call(void 0, null);
  _react.useEffect.call(void 0, () => {
    reset();
  }, [page, reset]);
  _react.useEffect.call(void 0, () => {
    if (page.endScreen) {
      fetch(`${formbricksUrl}/api/capture/forms/${formId}/submissions/${submissionId}`, {
        method: "PUT",
        headers: { "Content-Type": "application/json" },
        body: JSON.stringify({ finished: true })
      });
      onFinished({ submission });
    }
  }, [page, formId, formbricksUrl, submissionId]);
  const sendToFormbricks = (partialSubmission) => __async(this, null, function* () {
    var _a, _b, _c;
    const submissionBody = { data: partialSubmission };
    if (((_a = page.config) == null ? void 0 : _a.addFieldsToCustomer) && Array.isArray((_b = page.config) == null ? void 0 : _b.addFieldsToCustomer)) {
      for (const field of (_c = page.config) == null ? void 0 : _c.addFieldsToCustomer) {
        if (field in partialSubmission) {
          if (!("customer" in submissionBody)) {
            submissionBody.customer = {};
          }
          submissionBody.customer[field] = partialSubmission[field];
        }
      }
    }
    if (!submissionId) {
      const res = yield Promise.all([
        fetch(`${formbricksUrl}/api/capture/forms/${formId}/submissions`, {
          method: "POST",
          headers: { "Content-Type": "application/json" },
          body: JSON.stringify(submissionBody)
        }),
        fetch(`${formbricksUrl}/api/capture/forms/${formId}/schema`, {
          method: "POST",
          headers: { "Content-Type": "application/json" },
          body: JSON.stringify(schema)
        })
      ]);
      if (!res[0].ok || !res[1].ok) {
        alert("There was an error sending this form. Please contact us at hola@formbricks.com");
        return;
      }
      const submission2 = yield res[0].json();
      setSubmissionId(submission2.id);
    } else {
      const res = yield fetch(`${formbricksUrl}/api/capture/forms/${formId}/submissions/${submissionId}`, {
        method: "PUT",
        headers: { "Content-Type": "application/json" },
        body: JSON.stringify(submissionBody)
      });
      if (!res.ok) {
        alert("There was an error sending this form. Please contact us at hola@formbricks.com");
        return;
      }
    }
  });
  const submitPage = (data) => __async(this, null, function* () {
    setSubmittingPage(true);
    const updatedSubmission = __spreadValues(__spreadValues({}, submission), data);
    setSubmission(updatedSubmission);
    try {
      yield sendToFormbricks(data);
      setSubmittingPage(false);
      onPageSubmit({ submission: updatedSubmission, page, pageSubmission: data });
      window.scrollTo(0, 0);
    } catch (e) {
      console.error(e);
      alert("There was an error sending this form. Please contact us at hola@formbricks.com");
    }
  });
  const handleSubmitElement = () => {
    var _a, _b;
    if (((_a = page.config) == null ? void 0 : _a.autoSubmit) && page.elements.length == 1) {
      (_b = formRef.current) == null ? void 0 : _b.requestSubmit();
      setSubmittingPage(true);
    }
  };
  return /* @__PURE__ */ _jsxruntime.jsx.call(void 0, "form", { onSubmit: handleSubmit(submitPage), ref: formRef, children: page.elements.map((element) => {
    var _a, _b;
    const ElementComponent = element.component;
    return /* @__PURE__ */ _jsxruntime.jsx.call(void 0, "div", { children: element.name ? /* @__PURE__ */ _jsxruntime.jsx.call(void 0, 
      ElementComponent,
      {
        element,
        control,
        register,
        onSubmit: () => handleSubmitElement(),
        disabled: submittingPage,
        allowSkip: (_a = page.config) == null ? void 0 : _a.allowSkip,
        skipAction: onSkip,
        autoSubmit: (_b = page.config) == null ? void 0 : _b.autoSubmit,
        loading: submittingPage
      }
    ) : /* @__PURE__ */ _jsxruntime.jsx.call(void 0, ElementComponent, { element }) }, element.id);
  }) });
}

// src/components/FormbricksEngine.tsx

function FormbricksEngine({
  schema,
  formbricksUrl,
  formId,
  onFinished = () => {
  },
  onPageSubmit = () => {
  }
}) {
  if (!schema) {
    console.error("Formbricks Engine: No form provided");
    return null;
  }
  const [currentPage, setCurrentPage] = _react.useState.call(void 0, schema.pages[0]);
  const [submission, setSubmission] = _react.useState.call(void 0, {});
  const [finished, setFinished] = _react.useState.call(void 0, false);
  const cleanedSchema = _react.useMemo.call(void 0, () => generateSchema(schema), [schema]);
  _react.useEffect.call(void 0, () => {
    fetch(`${formbricksUrl}/api/capture/forms/${formId}/submissions`, {
      method: "OPTIONS"
    });
  }, []);
  const navigateToNextPage = (currentSubmission) => {
    const nextPage = calculateNextPage(schema, currentSubmission);
    setCurrentPage(nextPage);
    if (nextPage.endScreen) {
      setFinished(true);
    }
  };
  const calculateNextPage = (Form, submission2) => {
    if (currentPage.branchingRules) {
      for (const rule of currentPage.branchingRules) {
        if (rule.type === "value") {
          if (rule.value === submission2[rule.name]) {
            const nextPage = Form.pages.find((p) => p.id === rule.nextPageId);
            if (!nextPage) {
              throw new Error(`Next page ${rule.nextPageId} not found`);
            }
            return nextPage;
          }
        }
      }
    }
    const currentPageIdx = Form.pages.findIndex((p) => p.id === currentPage.id);
    return Form.pages[currentPageIdx + 1];
  };
  return /* @__PURE__ */ _jsxruntime.jsx.call(void 0, "div", { children: /* @__PURE__ */ _jsxruntime.jsx.call(void 0, 
    EnginePage,
    {
      page: currentPage,
      onSkip: () => navigateToNextPage(submission),
      onPageSubmit: ({ submission: submission2, page, pageSubmission }) => {
        navigateToNextPage(submission2);
        onPageSubmit({ submission: submission2, page, pageSubmission });
      },
      onFinished,
      submission,
      setSubmission,
      finished,
      formbricksUrl,
      formId,
      schema: cleanedSchema
    }
  ) });
}
function generateSchema(Form) {
  const schema = JSON.parse(JSON.stringify(Form));
  deleteProps(schema, "frontend");
  return schema;
}
function deleteProps(obj, propName) {
  if (Array.isArray(obj)) {
    for (let v of obj) {
      if (v instanceof Object) {
        deleteProps(v, propName);
      }
    }
    return;
  }
  delete obj[propName];
  for (let v of Object.values(obj)) {
    if (v instanceof Object) {
      deleteProps(v, propName);
    }
  }
}


exports.FormbricksEngine = FormbricksEngine;
